#!/usr/bin/perl -w
use strict;
#
#  Teleskop- und CCD-Berechung in Perl
#
my $autor   = "Panagiotis Xipteras";
my $sprache = "Perl 5.8";
my $zweck   = "Teleskop- und CCD-Berechung";
my $webpage = "http:\/\/www.AstroDigital.net";
my $garantie= "Fuer die Kalkulationen wird keine Haftung uebernommen.";
my $version = "1.16 - Standard licence";
#
#======================================================================

#     #
#     #    ##    #####      #      ##    #####   #       ######  #    #
#     #   #  #   #    #     #     #  #   #    #  #       #       ##   #
#     #  #    #  #    #     #    #    #  #####   #       #####   # #  #
 #   #   ######  #####      #    ######  #    #  #       #       #  # #
  # #    #    #  #   #      #    #    #  #    #  #       #       #   ##
   #     #    #  #    #     #    #    #  #####   ######  ######  #    #

my $vergr = undef ; 		# undef bedeutet undefiniert
my $maxvergr = undef ;
my $oeffnungVerhaelt = undef ;
my $maxOkBrennweite = undef ;
my $minOkBrennweite = undef ;
my $trennRayleigh = undef ;
my $trennDawes = undef ;
my $minvergr = undef;
my $linsen = undef;
my $typbez = undef;
my $limitMagnitude = undef;




#==============================================================================

#    #
#   #     ####   #    #   ####    #####    ##    #    #   #####  ######  #    #
#  #     #    #  ##   #  #          #     #  #   ##   #     #    #       ##   #
###      #    #  # #  #   ####      #    #    #  # #  #     #    #####   # #  #
#  #     #    #  #  # #       #     #    ######  #  # #     #    #       #  # #
#   #    #    #  #   ##  #    #     #    #    #  #   ##     #    #       #   ##
#    #    ####   #    #   ####      #    #    #  #    #     #    ######  #    #

#
#            SCHRITT 1 von 3:  HIER NUR EIN TELESKOP AUSWAEHLEN UND EINKOMMENTIEREN
#           -------------------+---------------+----------------------------------------------
#             Brennweite [mm]  | Oeffnung [mm] | "FLE" d.h. Reflektor (Newton,SC)
#                              |               | "FRA"      Achromat (Fraunhofen)
#                              |               | "SEMIAPO"  Semiapochromat (ED-Doublet)
#                              |               | "VOLLAPO"  Apochromat (FL-Doublet,ED-Triplet)
#           ===================+===============+==============================================
#
# ----------------------
# TAL - SIBERIA - GALAXY
# ----------------------
#
# my $brennweite = 1200;  my $oeffnung = 150; my $typ ="FLE";  my $modell="TAL-2M Newton (f/8)";
# my $brennweite = 750;   my $oeffnung = 150; my $typ ="FLE";  my $modell="TAL-150 Newton (f/5)";
#
# ----------------------
#      CELESTRON
# ----------------------
#
# my $brennweite = 2800;  my $oeffnung = 279; my $typ ="FLE";  my $modell="Celestron C11 (f/10)";
# my $brennweite = 1764;  my $oeffnung = 279; my $typ ="FLE";  my $modell="Celestron C11 (f/6.3)";
#
# ----------------------
#     PENTAX 
# ----------------------
#
my $brennweite = 1000;   my $oeffnung = 105;  my $typ ="VOLLAPO"; $linsen=2;  my $modell="Pentax 105SD (f/9.5)";
#
# ----------------------
#      TAKAHASHI
# ----------------------
#
# my $brennweite = 568;   my $oeffnung = 60;  my $typ ="VOLLAPO"; $linsen=2;  my $modell="Tak FS60C Refraktor with Extender-Q (f/9.6)";
# my $brennweite = 355;   my $oeffnung = 60;  my $typ ="VOLLAPO"; $linsen=2;  my $modell="Tak FS60C Refraktor (f/6)";
# my $brennweite = 265;   my $oeffnung = 60;  my $typ ="VOLLAPO"; $linsen=2;  my $modell="Tak FS60C Refraktor with Reducer (f/4.4)";
#
# my $brennweite = 500;   my $oeffnung = 90;  my $typ ="SEMIAPO"; $linsen=2;  my $modell="Tak Sky90 Refraktor";
#
# my $brennweite = 630;   my $oeffnung = 78;  my $typ ="VOLLAPO"; $linsen=2;  my $modell="Tak FS78  Refraktor (f/8)";
# my $brennweite = 472;   my $oeffnung = 78;  my $typ ="VOLLAPO"; $linsen=2;  my $modell="Tak FS78  Refraktor (f/6)";
#
# my $brennweite = 530;  my $oeffnung = 106; my $typ ="VOLLAPO"; $linsen=4;  my $modell="Tak FSQ106 Refraktor (f/5)";
#
# my $brennweite = 1312;  my $oeffnung = 102; my $typ ="VOLLAPO"; $linsen=2;  my $modell="Tak FS102 Refraktor (f/12.8)";
# my $brennweite = 820;   my $oeffnung = 102; my $typ ="VOLLAPO"; $linsen=2;  my $modell="Tak FS102 Refraktor (f/8)";
# my $brennweite = 610;   my $oeffnung = 102; my $typ ="VOLLAPO"; $linsen=2;  my $modell="Tak FS102 Refraktor (f/6)";
#
# my $brennweite = 500;   my $oeffnung = 180; my $typ ="FLE";              my $modell="Tak Epsilon 180ED (f/2.8)";
# my $brennweite = 2415;   my $oeffnung = 210; my $typ ="FLE";              my $modell="Tak Mewlon 210 (f/11.5)";
# my $brennweite = 2170;   my $oeffnung = 180; my $typ ="FLE";              my $modell="Tak Mewlon 180 (f/12)";
# my $brennweite = 1250;   my $oeffnung = 250; my $typ ="FLE";              my $modell="Tak BRC-250 (f/5)";
#
# my $brennweite = 1000;  my $oeffnung = 130;  my $typ ="VOLLAPO"; $linsen=3;  my $modell="Tak TOA-130 Refraktor (f/7.7)";
#
# ----------------------
#         VIXEN
# ----------------------
#
# my $brennweite = 1200;   my $oeffnung = 80;  my $typ ="FRA";  $linsen=2; my $modell="Vixen 80L Refraktor (f/15)";
#
# ----------------------
#         LIDL
# ----------------------
#
# my $brennweite = 700;   my $oeffnung = 70;  my $typ ="FRA";  $linsen=2; my $modell="LIDL 70mm Refraktor (f/10)";
#
# ----------------------
#      TESTOPTIK
# ----------------------
#
#my $brennweite = 1270;  my $oeffnung = 200;  my $typ ="FLE"; $linsen=2;  my $modell="TEST-SC8";



##
##    SCHRITT 2 von 3:  HIER NUR EINE CAMERA AUSWAEHLEN UND EINKOMMENTIEREN
##    =====================================================================
##
## ----------------------
##         MEADE
## ----------------------
##
## (1) Meade Deep Sky Imager - DSI
# my $CCDmodell ="Meade DSI";
# my $pixelSizeXMicrons = 9.6;  my $chipSizeWidthInPixel  = 510;
# my $pixelSizeYMicrons = 7.5;  my $chipSizeHeightInPixel = 492;
##
## ----------------------
##         SBIG
## ----------------------
##
# (2) SBIG ST-7 XME
my $CCDmodell ="SBIG ST-7 XME";
my $pixelSizeXMicrons = 9;  my $chipSizeWidthInPixel  = 765;
my $pixelSizeYMicrons = 9;  my $chipSizeHeightInPixel = 510;
##
## (3) SBIG ST-9 XE
#my $CCDmodell ="SBIG ST-9 XE";
#my $pixelSizeXMicrons = 20;  my $chipSizeWidthInPixel  = 512;
#my $pixelSizeYMicrons = 20;  my $chipSizeHeightInPixel = 512;
##
# ----------------------
#       TEST CCD
# ----------------------
#
# (4) TEST-CCD
#my $CCDmodell ="TEST-CCD 6.8 mu";
#my $pixelSizeXMicrons = 6.8;  my $chipSizeWidthInPixel  = 765;
#my $pixelSizeYMicrons = 6.8;  my $chipSizeHeightInPixel = 510;


##
##    SCHRITT 3 von 3: ABSPEICHERN UND AUF KOMMANDOZEILENEBENE EINGEBEN:
##                          perl teleskop.pl 
##    =====================================================================
##



#==============================================================================

                         #####
                        #     #   ####   #####   ######
                        #        #    #  #    #  #
                        #        #    #  #    #  #####
                        #        #    #  #    #  #
                        #     #  #    #  #    #  #
                         #####    ####   #####   ######

# ===================
# TELESKOP Berechnung
# ===================
#
print "\n";
print "=" x 54 , "\n";   # mehrere Striche nebeneinander
print "$zweck (V$version)\n";
print "Autor: $autor\n";
print "$webpage\n";
print "$garantie\n";
print "=" x 54 , "\n\n";   # mehrere Striche nebeneinander

if ($typ =~ "VOLLAPO")
{
    $maxvergr = (($oeffnung/10)/2.5) * 100 ; # 100x pro Zoll Oeffnung
    $typbez = "Vollapochromat";
}
elsif ($typ =~ "SEMIAPO")
{
    $maxvergr = $oeffnung * 3; # 3x die Oeffnung in cm
    $typbez = "Semiapochromat";
}
elsif ($typ =~ "FRA")
{
    $maxvergr = $oeffnung * 2; # 2x die Oeffnung in cm
    $typbez = "Achromat";
}
else  #  ($typ =~ "FLE")
{
    $maxvergr = $oeffnung * 1.5 ; # 1.5x die Oeffnung in cm
    $typbez = "Reflektor";
}

$oeffnungVerhaelt = $brennweite/$oeffnung;
$maxOkBrennweite = $oeffnungVerhaelt * 7;
$minOkBrennweite = $brennweite/$maxvergr ;
$trennRayleigh = 13.8/($oeffnung/10);
$trennDawes = 11.7/($oeffnung/10);
$minvergr = $brennweite/$maxOkBrennweite;
$limitMagnitude = 8.8 + 5 * (log($oeffnung/25)/log(10)); # 25 means is 2.5 inches * 10


print "$modell\n";
print "Typ = ", $typbez , "\n";
print "Brennweite = $brennweite mm\n";
print "Oeffnung = $oeffnung mm\n";
printf "Oeffnungsverhaeltnis = f/%3.1f" , $oeffnungVerhaelt ;
printf "\n";
printf "Trennung (Rayleigh)= %3.2f ''", $trennRayleigh ;
printf "\n";
printf "Trennung (Dawes)= %3.2f ''", $trennDawes ;
printf "\n";
printf "Visuelle Grenzgroesse= %3.2f mag", $limitMagnitude ;
printf "\n";

#print "-" x 10 , "\n";   # 10 Striche nebeneinander

printf "Abs.Min.Vergr. = %3.1f" , $minvergr ;
printf "x mit Ok = %3.1f" , $maxOkBrennweite;
printf "mm\n";

printf "Min. Vergr. (Trennung erhalten) =  %3.0f" , $oeffnung/2;
printf "x mit Ok= %3.1f" , $brennweite / ($oeffnung/2);
print "mm\n";

printf "Foerderliche Vergr. = %3.0f" , $oeffnung;
printf "x mit Ok = %3.1f" , $brennweite / $oeffnung;
printf "mm\n";

printf "Sinnvolle MaxVergr = %3.0f" , $maxvergr ;
printf "x mit Ok = %3.1f" , $brennweite / $maxvergr ;
printf "mm\n";

printf "Min.Okularbrennweite = %3.1f", $minOkBrennweite ;
print  "mm\n";

printf "Max.Okularbrennweite = %3.1f", $maxOkBrennweite ;
print  "mm\n";

printf "Lichtsammelvermoegen %3.0fx mehr als das menschliche Auge\n", ($oeffnung * $oeffnung) / 49;
print  "\n\n";


# ==================
# Berechnung Okulare
# ==================
#
print "\nOKULAR Berechnung\n";
print "=" x 17 , "\n";   # 17 Striche nebeneinander
#
#  Oeffnung GF  mm Brennweite MinVergr MaxVergr Typ
#
Oku($oeffnung, 45, 40, $brennweite, $maxvergr, $minvergr, "Super Plossl");
#Oku($oeffnung, 45, 30, $brennweite, $maxvergr, $minvergr, "Super Plossl");
Oku($oeffnung, 52, 25, $brennweite, $maxvergr, $minvergr, "Super Plossl");
Oku($oeffnung, 57, 25, $brennweite, $maxvergr, $minvergr, "Koenig");
Oku($oeffnung, 68, 20, $brennweite, $maxvergr, $minvergr, "TSW");
Oku($oeffnung, 52, 12, $brennweite, $maxvergr, $minvergr, "Takahashi LE");
Oku($oeffnung, 45, 10, $brennweite, $maxvergr, $minvergr, "Super Plossl");
Oku($oeffnung, 52, 7.5,$brennweite, $maxvergr, $minvergr, "Super Plossl");
Oku($oeffnung, 52, 5,  $brennweite, $maxvergr, $minvergr, "Takahashi LE");
Oku($oeffnung, 45, 4, $brennweite, $maxvergr, $minvergr, "Vixen LV");
Oku($oeffnung, 45, 2.8,  $brennweite, $maxvergr, $minvergr, "Takahashi LE");
Oku($oeffnung, 60, 3,  $brennweite, $maxvergr, $minvergr, "Televue Radian");

print "\n\n";



# =======================
# Berechnung Lichtstaerke
# =======================
#
print "\nLICHTSTAERKE Berechnung\n";
print "=" x 23 , "\n";   # 23 Striche nebeneinander
lichtstaerke(550, $oeffnung, $brennweite); # in 550nm (yellow light)
print "\n\n";




# =======================
# Berechnungen CCD-Camera
# =======================
#
print "\nCCD Berechnung\n";
print "=" x 14 , "\n";   # 14 Striche nebeneinander

my $pixelSizeAverageMicrons = ($pixelSizeXMicrons + $pixelSizeYMicrons) / 2 ;
my $amountOfSkyPerPixel = (206.265 / $brennweite ) * $pixelSizeAverageMicrons ;
my $amountOfSkyWidthPerPixel = (206.265 / $brennweite ) * $pixelSizeXMicrons ;
my $amountOfSkyHeigthPerPixel = (206.265 / $brennweite ) * $pixelSizeYMicrons ;

my $fieldOfViewWidthInArcSec  = $amountOfSkyWidthPerPixel * $chipSizeWidthInPixel;
my $fieldOfViewHeigthInArcSec = $amountOfSkyHeigthPerPixel * $chipSizeHeightInPixel;

use integer; # Integer-Arithmetik zwingen ----------------

my $fieldOfViewWidthInArcMin     = $fieldOfViewWidthInArcSec  / 60;
my $fieldOfViewHeigthInArcMin    = $fieldOfViewHeigthInArcSec / 60;
my $fieldOfViewWidthInArcMinSec  = $fieldOfViewWidthInArcSec  % 60;
my $fieldOfViewHeigthInArcMinSec = $fieldOfViewHeigthInArcSec % 60;

print "Cameratyp: $CCDmodell\n";
print "Chipgroesse (BxH) [Pixel] = $chipSizeWidthInPixel x $chipSizeHeightInPixel\n";
print "Durchschittliche Pixelgroesse [Mikrometer] = $pixelSizeAverageMicrons\n";
printf "Firmamentflaeche pro Pixel [arcsec] = %3.2f\n", $amountOfSkyPerPixel;

#printf "Field of View in arc-seconds  = %3.2f x %3.2f\n", $fieldOfViewWidthInArcSec, $fieldOfViewHeigthInArcSec;
printf "Gesichtsfeld (FOV) [arcsec] x [arcsec] = %3.0f'%3.0f'' x %3.0f'%3.0f''\n",
    $fieldOfViewWidthInArcMin,$fieldOfViewWidthInArcMinSec,
    $fieldOfViewHeigthInArcMin, $fieldOfViewHeigthInArcMinSec;
print "\n\n";


# ==========================
# Visualisierung FOV der CCD
# ==========================
#
print "\nVisualisierung FOV der CCD\n";
print "=" x 26 , "\n";   # Striche nebeneinander
showFOV($fieldOfViewWidthInArcMin,$fieldOfViewHeigthInArcMin);


no integer; # auf Floating-Point-Arithmetik zurueckwechseln -------

print "\n\n";




# ===========
# Bemerkungen
# ===========
#
print "\nBEMERKUNGEN\n";
print "=" x 11 , "\n";   # 11 Striche nebeneinander

# ----------
# FARBFEHLER
# ----------

if  ($typ =~ "FRA")	# Ein achromatischer Refraktor ?
 {
    if ($oeffnungVerhaelt < 15) { print "Bei Achromaten gibt es Farbfehler\n" ; }
    else { print "Auch bei Achromaten KEIN Farbfehler\n" ; }
 }
elsif  ($typ =~ "SEMIAPO")	# Ein Semiapochromat ?
 {
    if ($oeffnungVerhaelt < 10)
    { print "Bei Semiapochromaten gibt es Farbfehler\n" ; }
    else { print "Auch bei Semiapochromaten KEIN Farbfehler\n" ; }
 }
else
 {
  print "keine\n";
 }

# ------------------
# TRENNUNGSVERMOEGEN
# ------------------

if ($trennRayleigh > 2.5)
{
    print "Ungenuegende Separationsfaehigkeit. Die Trennung liegt bei ueber 2''.5 Bogensekunden. Geraet evtl. unbrauchbar.\n" ;
}

# ------------------------------
# ZUSAMMENSPIEL TELESKOP <-> CCD
# ------------------------------
#
#  Es muss $amountOfSkyPerPixel > $trennRayleigh
#
if ($amountOfSkyPerPixel > $trennRayleigh)
{
    print "TIPP: Sie koennen auch eine CCD mit kleineren Pixeln verwenden, um die Aufloesung der Fotos zu verbessern\n"; 
}
elsif (int($amountOfSkyPerPixel*100) == int($trennRayleigh*100))
{
    print "INFO: Die CCD-Pixel haben fuer dieses Teleskop die optimale Groesse\n";
}
else
{
    print "TIPP: Die CCD-Pixel koennten groesser sein, weil das Teleskop sie sowieso nicht ausreizen kann\n";
}


print "\n";



#==============================================================================

#######
#        #    #  #    #  #    #   #####     #     ####   #    #  ######  #    #
#        #    #  ##   #  #   #      #       #    #    #  ##   #  #       ##   #
#####    #    #  # #  #  ####       #       #    #    #  # #  #  #####   # #  #
#        #    #  #  # #  #  #       #       #    #    #  #  # #  #       #  # #
#        #    #  #   ##  #   #      #       #    #    #  #   ##  #       #   ##
#         ####   #    #  #    #     #       #     ####   #    #  ######  #    #


sub wahrGesFeld
{
    my ($GFOku, $BrennwOku, $BrennwTel);	# Argumente deklarieren
    ($GFOku, $BrennwOku, $BrennwTel) = @_;    	# Argumente zerlegen (ACHTUNG: @liste muss am Schluss sein)
    
    my $vergr;
    my $wgf;
    
    $vergr = $BrennwTel / $BrennwOku;
    $wgf = $GFOku / $vergr;
 
    return $wgf;
}

#########################



sub Oku
{
    my ($oeffnungTeleskop, $gfoku, $mm, $brennweite, $maxvergr, $minvergr, $bez);   # Argumente deklarieren
    ($oeffnungTeleskop, $gfoku, $mm, $brennweite, $maxvergr, $minvergr, $bez) = @_; # Argumente zerlegen

    $vergr = $brennweite / $mm ;
    my $austrittspupille = $oeffnungTeleskop / $vergr;

    printf "Mit %-15s| %2.0fmm (FOV=%2.0f), Vergroesserung=%3.0fx", $bez , $mm , $gfoku , $vergr ;
    
    if ($vergr > $maxvergr)
    {
	print " ist zu hoch!\n";
    }
    elsif ($vergr < $minvergr)
    {
	print " ist zu niedrig!\n";
    }
    else
    {
	printf ", wahres Gesichtsfeld=%3.2f", wahrGesFeld($gfoku, $mm, $brennweite);
	printf ", Austrittspupille=%3.2f mm\n", $austrittspupille ;
    }

}


#########################


sub lichtstaerke
{
#
# $Lamda = 550nm => gelbes Licht
#
#        [nm]      [cm]         [cm]
    my ($Lamda, $OeffnungTel, $BrennwTel);   # Argumente deklarieren
    ($Lamda, $OeffnungTel, $BrennwTel) = @_; # Argumente zerlegen
    
    my $ls;        # Lichtstaerke von diesem Teleskop
    my $lsFS102f8; # Lichtstaerke eine FS102 (820mm,f/8)
    my $lsFS102f6; # Lichtstaerke eine FS102 (610mm,f/6)

    $ls = (($OeffnungTel/$Lamda)**2) * (($OeffnungTel/$BrennwTel)**2) ;
    $lsFS102f8 = ((102/$Lamda)**2) * ((102/820)**2);
    $lsFS102f6 = ((102/$Lamda)**2) * ((102/610)**2);

    printf "Bei einer Lichtfrequenz von %3.0f nm\n",$Lamda;
    printf "hat dieses Teleskop eine Lichtstaerke von: %3.0f\n", $ls*10E7;
    printf "Es ist %3.2f x lichtstaerker als ein Takahashi FS-102 (f/8)\n", $ls/$lsFS102f8;
    printf "und %3.2f x lichtstaerker als ein Takahashi FS-102 (f/6)\n", $ls/$lsFS102f6;

    return $ls;
}



#########################



sub showFOV
{
#
#      [arcmin]  [arcmin]
    my ($xachse, $yachse);      # Argumente deklarieren
       ($xachse, $yachse) = @_; # Argumente zerlegen
    
    my $xM51=8;  # Breite von M51 (Strudelgalaxie) in [arcmin]
    my $yM51=4;  # Laenge von M51 (Strudelgalaxie) in [arcmin]

    print "X => ist die FOV des Systems\n";
    print "o => ist die Flaechenbelegung von M51 auf dem CCD-Chip\n";
    print "\n";

    for (my $y=0; $y<$yachse; $y++)
    {
	for (my $x=0; $x<$xachse; $x++)
	{
	    if (($x<$xM51) && ($y<$yM51))  { printf "o"; }
	    else { printf "X"; }
	}
	printf "\n";
    }
    
    return 0;
}



# PROGRAMMENDE
